//
//  AppDelegate.m
//  ICTRasterizer
//
//  Created by masao Fujioka on 2018/12/07.
//  Copyright © 2018 masao Fujioka. All rights reserved.
//

#import "AppDelegate.hpp"

#include "Stub.hpp"

static NSTimer* s_pTimer;

@interface AppDelegate ()

@property (weak) IBOutlet NSWindow *window;
@end

@implementation AppDelegate

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification {
    // Insert code here to initialize your application
    NSLog(@"<HomeDirectory>=%s", [NSHomeDirectory() UTF8String]);

    [_window setDelegate: self];
    [NSTimer scheduledTimerWithTimeInterval:1.0/60.0 target:self selector:@selector(OnTimer:) userInfo:nil repeats:YES];
    
    int w = _window.contentView.frame.size.width;
    int h = _window.contentView.frame.size.height;
    if (stubStartup(w, h) == false) {
        [NSApp terminate:self];
        return;
    }
}


- (void)applicationWillTerminate:(NSNotification *)aNotification {
    // Insert code here to tear down your application
    stubCleanup();
    NSLog(@"Terminate");
}

- (BOOL)windowShouldClose:(NSWindow *)sender {
    NSLog(@"Close");
    [NSApp terminate:self];
    return YES;
}

- (void)OnTimer:(NSTimer *)timer
{
    stubOnTimer();
}

@end
