//
//  Bits.cpp
//  ICTRasterizer
//
//  Created by masao Fujioka on 2018/12/05.
//  Copyright © 2018 masao Fujioka. All rights reserved.
//

#include "Bits.hpp"

bool createBits(int w, int h, DWORD** ppBits, CGContextRef* ppBitsContext) {
    DWORD pitch = w * sizeof(DWORD);
    *ppBits = new DWORD[w * h];
    if (*ppBits == NULL) {
        return false;    // 失敗
    }
    memset(*ppBits, 0, sizeof(DWORD) * w * h);

    CGColorSpaceRef colorSpace = CGColorSpaceCreateWithName(kCGColorSpaceSRGB);
    *ppBitsContext = CGBitmapContextCreate(*ppBits, w, h, 8,
                        pitch, colorSpace, kCGImageAlphaPremultipliedFirst
                                           | kCGBitmapByteOrder32Little);
    CGColorSpaceRelease(colorSpace);
    if (*ppBitsContext == NULL) {
        return false;    // 失敗
    }
    
    return true;
}
