#ifndef _Clip_hpp_
#define _Clip_hpp_

#include "Porting.hpp"

#include "Coordinate.hpp"

// プロジェクション変換後の視錐台でクリッピングするのではなく
// ビューポート変換まで行ってからクリッピングしている

class CClip
{
private:
	CClip();

private:
	int nVertex;
	int getVertex;
	CVertexFormat s[3 + 6];
	CVertexFormat d[3 + 6];

	int zMin;
	int zMax;
	int xMin;
	int xMax;
	int yMin;
	int yMax;

public:
	CClip(const CVertexFormat& c0, const CVertexFormat& c1, const CVertexFormat& c2,
		int w, int h);
	virtual ~CClip() {}

private:
	void nearClip();
	void farClip();
	void leftClip();
	void rightClip();
	void topClip();
	void bottomClip();

public:
	bool getTriangle(CVertexFormat* pC0, CVertexFormat* pC1, CVertexFormat* pC2);
};

#endif /* _Clip_hpp_ */
