//
//  CustomView.m
//  ICTRasterizer
//
//  Created by masao Fujioka on 2018/12/07.
//  Copyright © 2018 masao Fujioka. All rights reserved.
//

#import "CustomView.hpp"

#include "CustomViewSetup.hpp"


static bool s_bSetup = false;
static CGRect s_contentRect;
static DWORD* s_pBits;
static CGContextRef s_bitsContext;
static CustomView* s_pCustomView = NULL;

void customViewSetup(int w, int h, DWORD* pBits, CGContextRef bitsContext) {
    s_bSetup = true;
    s_contentRect = CGRectMake(0, 0, w, h);
    s_pBits = pBits;
    s_bitsContext = bitsContext;
}
void customViewTerminate() {
    s_bSetup = false;
}
void customViewTimer() {
    if (s_pCustomView == NULL) {
        return;
    }
    [s_pCustomView setNeedsDisplayInRect:s_contentRect];
}

@implementation CustomView

- (id)initWithFrame:(NSRect)frame
{
    self = [super initWithFrame:frame];
    s_pCustomView = self;
    return self;
}

- (void)drawRect:(NSRect)dirtyRect {
    [super drawRect:dirtyRect];
    
    if (!s_bSetup) {
        return;
    }
    // Drawing code here.
    // Alphaチャネルを0xffで不透明にする
    for (int i = 0; i < s_contentRect.size.width * s_contentRect.size.height; i++) {
        s_pBits[i] |= 0xff000000;
    }
    CGContextRef cgContext = [[NSGraphicsContext currentContext] CGContext];
    CGImageRef bitsImage = CGBitmapContextCreateImage(s_bitsContext);
    CGContextDrawImage(cgContext, s_contentRect, bitsImage);
    CGImageRelease(bitsImage);
}

@end
