#ifndef _Matrix_hpp_
#define _Matrix_hpp_

#include "Porting.hpp"

#include "Coordinate.hpp"

#ifndef M_PI
#define M_PI 3.1415926535897932384626433832795
#endif

class CMatrix
{
public:
	CMatrix() {
		identity();
	}

private:
	float m[4][4];

public:
	void identity();
	void multiply(const CMatrix& d);
	CVector multiply(float x, float y, float z);
	void translate(float x, float y, float z);
	void scale(float s);
	void rotateX(float angle);
	void rotateY(float angle);
	void rotateZ(float angle);

	void lookAt(const CVector& position, const CVector& target, const CVector& up);
	void projection(float fov, float aspect, float zNear, float zFar);
	void viewport(int w, int h);
	bool transform(int* pX, int* pY, int* pZ, int* pRHW, const VERTEX& v);
};

const int zFar = 1024;

#endif /* _Matrix_hpp_ */
