#ifndef _Scan_hpp_
#define _Scan_hpp_

#include "Porting.hpp"

class CScan
{
private:
	CScan();

public:
	CScan(int s, int e, int n0, int n1)
	{
		this->s = s;
		this->e = e;
		this->n0 = n0;
		this->n1 = n1;

		seDiff = e - s;

		nUnit = 1;
		nDiff = n1 - n0;
		if (nDiff < 0) {
			nUnit = -1;
			nDiff = -nDiff;
		}

		eTerm = 0;
		len = 0;
		i = s;

		bFirst = true;
	}

private:
	int s, e, n0, n1;
	int seDiff;
	int nUnit, nDiff;
	int eTerm;
	int len, i;
	bool bFirst;

public:
	bool linear(int* pI, int* pN)
	{
		if (bFirst) {
			bFirst = false;
			*pI = i;
			*pN = n0;
			return true;
		}
		if (seDiff < nDiff) {
			while (i < e && len < nDiff) {
				n0 += nUnit;
				len++;
				eTerm += seDiff;
				if (nDiff < eTerm) {
					eTerm -= nDiff;
					i++;
					*pI = i;
					*pN = n0;
					return true;
				}
			}
		}
		else {
			if (i < e) {
				eTerm += nDiff;
				if (seDiff < eTerm) {
					eTerm -= seDiff;
					n0 += nUnit;
				}
				i++;
				*pI = i;
				*pN = n0;
				return true;
			}
		}
		*pI = i;
		*pN = n0;
		return false;
	}
};

#endif /* _Scan_hpp_ */
