//
//  Stub.cpp
//  ICTRasterizer
//
//  Created by masao Fujioka on 2018/12/04.
//  Copyright © 2018 masao Fujioka. All rights reserved.
//

#include "Porting.hpp"

#include "Stub.hpp"
#include "Frame.hpp"
#include "App.hpp"

#include "Bits.hpp"

#include "CustomViewSetup.hpp"

static int s_W;
static int s_H;

static DWORD* s_pBits;
static CFrame* s_pFrame;
static CApp* s_pApp;

static CGContextRef s_bitsContext;

bool stubStartup(int w, int h) {
    s_W = w;
    s_H = h;
    
    if (createBits(w, h, &s_pBits, &s_bitsContext) == false) {
        return false;    // 失敗
    }
    memset(s_pBits, 0, sizeof(DWORD) * w * h);
    
    // スタートアップの起動
    s_pFrame = new CFrame(w, h, s_pBits);
    s_pApp = ::appStartup(s_pFrame);
    
    customViewSetup(w, h, s_pBits, s_bitsContext);
    
    return true;
}
void stubCleanup() {
    customViewTerminate();
    
    delete s_pApp;
    s_pApp = NULL;
    
    delete s_pFrame;
    
    CGContextRelease(s_bitsContext);
    delete[] s_pBits;
}
void stubOnTimer() {
    // 描画処理の呼び出し
    s_pFrame->clear();
    if (s_pApp != NULL && s_pApp->appDraw()) {
        customViewTimer();
    }
}
