#include "Texture.hpp"
#include "Bits.hpp"

CTexture::CTexture(const char* pPath)
{
    NSString* pNSStr = [NSString stringWithCString:pPath encoding:NSUTF8StringEncoding];
    NSURL* url = [NSURL fileURLWithPath:pNSStr];

    // ファイルを読み込む
    NSError* error = nil;
    NSData* imageData = [NSData dataWithContentsOfURL:url options:NSDataReadingUncached error:&error];
    if (error) {
        NSLog(@"%@ code=%d", [error domain], (int)[error code]);
        exit(0);
    }
    CGImageSourceRef imageSource =  CGImageSourceCreateWithData((CFMutableDataRef)imageData, NULL);
    if (imageSource == NULL) {
        return;    // 失敗
    }
    // 一つ目を取り出す
    CGImageRef image = CGImageSourceCreateImageAtIndex(imageSource, 0, NULL);
    CFRelease(imageSource);
    
    // イメージの大きさでオフスクリーンテクスチャを生成する
    w = (int)CGImageGetWidth(image);
    h = (int)CGImageGetHeight(image);
    CGContextRef cgContext;
    if (createBits(w, h, &m_pBits, &cgContext) == false) {
        CFRelease(image);
        return;    // 失敗
    }
    
    // イメージの内容をオフスクリーンテクスチャにコピーする
    CGRect imageRect = CGRectMake(0, 0, w, h);
    CGContextDrawImage(cgContext, imageRect, image);
    CFRelease(image);
    CGContextRelease(cgContext);
}


CTexture::~CTexture()
{
    delete[] m_pBits;
}
